diff -urN sourceold/scripts/jmgBearHunter.cpp source/scripts/jmgBearHunter.cpp
--- sourceold/scripts/jmgBearHunter.cpp	2019-08-20 10:11:06.805000100 +1000
+++ source/scripts/jmgBearHunter.cpp	2020-09-26 08:59:57.398127800 +1000
@@ -2099,6 +2028,143 @@
 		JMG_Bear_Hunter_Oil_Rig::pumpJacks[x] = JMG_Bear_Hunter_Oil_Rig::PumpjackNode(0);
 	cleanUpNeeded = false;
 }
+void JMG_Bear_Hunter_Game_Control::CreateNormalAnimals(int normalBears)
+{
+	if ((int)(normalBears * 0.25f) > JMG_Bear_Hunter_AI_Avoid_Enemies::wildAnimalCount)
+	{
+		bool deer = Commands->Get_Random(0.0f,1.0f) < 0.5f;
+		Vector3 pos = BearHunterGameControlSystem.LookupNearestPosition(Vector2(Commands->Get_Random(-500.0f,500.0f),Commands->Get_Random(-350.0f,500.0f)));
+		GameObject *ai = deer ? Commands->Create_Object("Normal_Buck_Twiddler",pos) : Commands->Create_Object("Normal_Squirrel_Twiddler",pos);
+		Commands->Set_Facing(ai,Commands->Get_Random(-180,180));
+		MoveablePhysClass *mphys = ai->As_PhysicalGameObj() ? ai->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass() : NULL;
+		if (mphys)
+			mphys->Find_Teleport_Location(pos,2.0f,&pos);
+		Commands->Set_Position(ai,pos);
+		if (deer)
+		{
+			Attach_Script_Once(ai,"JMG_Utility_AI_Skittish_Herd_Animal","0,4,511,25.0,30.0,50.0,200.0,6.0,24.0,10.0,25.0,0.1,0.125");
+			Commands->Set_Model(ai,Commands->Get_Random(0.0f,1.0f) < 0.25f ? "BUCK_" : "DOE_");
+		}
+		else
+			Attach_Script_Once(ai,"JMG_Bear_Hunter_AI_Avoid_Enemies","0");
+		Attach_Script_Once(ai,"JMG_Security_Camera_Behavior_Ignore","");
+		Attach_Script_Once(ai,"JMG_Bear_Hunter_Give_AI_Cash_For_Kills","");
+	}
+}
+void JMG_Bear_Hunter_Game_Control::CreateMouse()
+{
+	if (gameTime == 0 ? 5 : 1 > JMG_Bear_Hunter_AI_Avoid_Enemies::mouseAnimalCount)
+	{
+		Vector3 pos = JMG_Wandering_AI_Controller::wanderPoints.GetRandomFromGroup(751)->position;
+		GameObject *mouse = Commands->Create_Object("Normal_Mouse_Twiddler",pos);
+		Commands->Set_Facing(mouse,Commands->Get_Random(-180,180));
+		MoveablePhysClass *mphys = mouse->As_PhysicalGameObj() ? mouse->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass() : NULL;
+		if (mphys)
+			mphys->Find_Teleport_Location(pos,0.5f,&pos);
+		Commands->Set_Position(mouse,pos);
+		Attach_Script_Once(mouse,"JMG_Bear_Hunter_AI_Avoid_Enemies","1");
+		Attach_Script_Once(mouse,"JMG_Security_Camera_Behavior_Ignore","");
+		Commands->Set_Is_Visible(mouse,false);
+	}
+}
+void JMG_Bear_Hunter_Game_Control::CreateBears(int normalBears)
+{
+	for (int x = bearObjectListControl.objectCount;x < normalBears;x++)
+	{
+		Vector3 pos = BearHunterGameControlSystem.LookupNearestPosition(Vector2(Commands->Get_Random(-500.0f,500.0f),Commands->Get_Random(-350.0f,500.0f)));
+		bool isBlackBear = Commands->Get_Random(0.0f,1.0f) < 0.1 ? true : false;
+		GameObject *ai = isBlackBear ? Commands->Create_Object("Bear_Black_Twiddler",pos) : Commands->Create_Object("Normal_Bear_Twiddler",pos);
+		Commands->Set_Facing(ai,Commands->Get_Random(-180,180));
+		MoveablePhysClass *mphys = ai->As_PhysicalGameObj() ? ai->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass() : NULL;
+		if (mphys)
+			mphys->Find_Teleport_Location(pos,2.0f,&pos);
+		pos.Z += 0.1f;
+		Commands->Set_Position(ai,pos);
+		Commands->Set_Loiters_Allowed(ai,true);
+		ai->As_SoldierGameObj()->Set_Override_Muzzle_Direction(true);
+		bearObjectListControl += ai;
+		Attach_Script_Once(ai,"JMG_Rp2_Hostile_Mutant_AI","");
+		Attach_Script_Once(ai,"JMG_Bear_Hunter_Bear_Tracker","");
+		Attach_Script_Once(ai,"JMG_Bear_Hunter_Animal_Control","");
+		Attach_Script_Once(ai,"JMG_Bear_Hunter_Player_Count_Scaled_Object_Health","");
+	}
+}
+void JMG_Bear_Hunter_Game_Control::SpawnAngryTinyDeer()
+{
+	if (JMG_Bear_Hunter_Golden_Deer_Statue::playerWithTheStatue)
+	{
+		GameObject *statuePlayer = Get_GameObj(JMG_Bear_Hunter_Golden_Deer_Statue::playerWithTheStatue);
+		if (statuePlayer)
+		{
+			int deerCount = JmgUtility::MathClampInt(3+(int)(0.33f*Get_Player_Count()),3,25);
+			for (int x = 0;x < deerCount;x++)
+			{
+				if (Commands->Find_Object(JMG_Bear_Hunter_Golden_Deer_Statue::tinyDeerIds[x]))
+					continue;
+				Vector3 playerPos = Commands->Get_Position(statuePlayer);
+				if (BearHunterGameControlSystem.getRandomPosition(&playerPos,500.0f,2500.0f))
+				{
+					GameObject *tinyDeer = Commands->Create_Object("Tiny_Deer_Twiddler",playerPos);
+					MoveablePhysClass *mphys = tinyDeer->As_PhysicalGameObj() ? tinyDeer->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass() : NULL;
+					if (mphys && !mphys->Can_Teleport(Matrix3D(playerPos)))
+					{
+						mphys->Find_Teleport_Location(playerPos,1.5f,&playerPos);
+						Commands->Set_Position(tinyDeer,playerPos);
+					}
+					tinyDeer->As_SoldierGameObj()->Set_Override_Muzzle_Direction(true);
+					Commands->Attach_Script(tinyDeer,"JMG_Utility_AI_Goto_Player","-1.0,1.0,1.0,0.0,0,1.0,-1.0,0.0,0,1.0,-1,1.0,1,0,0.0");
+					Commands->Attach_Script(tinyDeer,"JMG_Bear_Hunter_Kill_Score_Tracker","");
+					JMG_Bear_Hunter_Golden_Deer_Statue::tinyDeerIds[x] = Commands->Get_ID(tinyDeer);
+				}
+			}
+		}
+	}
+}
+void JMG_Bear_Hunter_Game_Control::CreateCow()
+{
+	cowWanderId = Commands->Get_Random(0.0f,1.0f) < 0.5f ? 4588 : 4589;
+	Rp2SimplePositionSystem::SimplePositionNode *node = JMG_Wandering_AI_Controller::wanderPoints.GetRandomFromGroup(cowWanderId);
+	if (!node)
+		return;
+	GameObject *cow = Commands->Create_Object("Cow_Twiddler",node->position);
+	Vector3 pos = node->position;
+	MoveablePhysClass *mphys = cow->As_PhysicalGameObj() ? cow->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass() : NULL;
+	if (mphys)
+		mphys->Find_Teleport_Location(pos,2.0f,&pos);
+	char params[256];
+	sprintf(params,"%d,0.33,-1.0,1,1,1.0,0.0,1,0,0",cowWanderId);
+	Commands->Attach_Script(cow,"JMG_Bear_Hunter_AI_Guardian_Generic",params);
+	cowId = Commands->Get_ID(cow);
+}
+void JMG_Bear_Hunter_Game_Control::TriggerCowObjective()
+{
+	if (NewObjectiveSystemControl.Get_Objective_Status(27) != NewObjectiveSystem::NotDefined)
+		return;
+	GameObject *cow = Commands->Find_Object(cowId);
+	if (!cow)
+		return;
+	for (int x = 1;x < 128;x++)
+	{
+		GameObject *player = Get_GameObj(x);
+		if (!player)
+			continue;
+		player = Get_Vehicle(player) ? Get_Vehicle(player) : player;
+		SmartGameObj *object = player->As_SmartGameObj();
+		if (object->Is_Visible() && cow->As_SmartGameObj()->Is_Obj_Visible(object))
+		{
+			if (object->Peek_Physical_Object())
+			{
+				RenderObjClass* model = object->Peek_Physical_Object()->Peek_Model();
+				if (model && model->Is_Hidden())
+					continue;
+			}
+			BearHunterVoiceSystem::PlayVoice("BH97.mp3","Bear Rug Co: Hey there's our lost cow! Why not give it a poke and lead it back to the barn!");
+			IncreaseBonusObjectiveCount(27);
+			NewObjectiveSystemControl.Add_Objective(27,NewObjectiveSystem::Bonus,NewObjectiveSystem::Pending,12857,"",12857,bonusObjectiveCount);
+			return;
+		}
+	}
+}
 GameObject *JMG_Bear_Hunter_Game_Control::MutantSpawn()
 {
 	const char *preset;
@@ -2129,7 +2195,7 @@
 	pos.Z += 1.0f;
 	Commands->Set_Position(ai,pos);
 	float maxHealth = Commands->Get_Max_Health(ai);
-	float calculatedHealth = JmgUtility::MathClamp(maxHealth*(GamePercent*0.5f+Commands->Get_Random(0.0f,0.1f)),1.0f,maxHealth*(0.055f+(Get_Player_Count()-1)*0.0375f));//0.025 easy
+	float calculatedHealth = JmgUtility::MathClamp(maxHealth*(GamePercent*0.5f+Commands->Get_Random(0.0f,0.1f)),1.0f,maxHealth*(0.06f+(Get_Player_Count()-1)*0.0375f));//0.025 easy
 	Commands->Set_Health(ai,calculatedHealth);
 	Set_Max_Health(ai,calculatedHealth*2.0f);
 	mutantObjectListControl += ai;
@@ -2140,6 +2206,7 @@
 	Attach_Script_Once(ai,"JMG_Bear_Hunter_Mutant_Tracker","");
 	Attach_Script_Once(ai,"JMG_Bear_Hunter_Animal_Control","");
 	Attach_Script_Once(ai,"JMG_Bear_Hunter_Mutant_Respawn_Tracker","");
+	Attach_Script_Once(ai,"JMG_Bear_Hunter_Give_AI_Cash_For_Kills","");
 	return ai;
 }
 void JMG_Bear_Hunter_Game_Control::IncreaseBonusObjectiveCount(int objectiveId)
@@ -2498,7 +2565,9 @@
 	if (ignoreEnemies)
 	{
 		int presetId = Commands->Get_Preset_ID(seen);
-		if (presetId != 1000001055 && presetId != 1000001536 && presetId != 1000001688 && presetId != 1000001690 && presetId != 1000001820)
+		if (JMG_Bear_Hunter_Game_Control::gameTime < 60 && presetId != 1000001040)
+			return;
+		if (presetId != 1000001055 && presetId != 1000001536 && presetId != 1000001688 && presetId != 1000001690 && presetId != 1000001820 && presetId != 1000001040)
 			return;
 	}
 	if (myNode->enemyId && JmgUtility::SimpleDistance(Commands->Get_Position(seen),Commands->Get_Position(obj)) > targetDistance)
@@ -2559,6 +2628,8 @@
 		float dist = JmgUtility::SimpleDistance(pos,lastPos);
 		if (dist < 1.0f)	
 		{
+			if (targetDistance < 100.0f && myNode->enemyId && (myNode->enemyId == JMG_Bear_Hunter_Game_Control::mutantTargetId || myNode->enemyId == JMG_Bear_Hunter_Radio_Tower_Switch::supportId || myNode->enemyId == JMG_Bear_Hunter_Power_Transformer::mctIds[0] || myNode->enemyId == JMG_Bear_Hunter_Power_Transformer::mctIds[1]))
+				stuckCount = 0;
 			stuckCount++;
 			if (stuckCount == 25)
 			{
@@ -2712,7 +2783,7 @@
 			for (int x = 0;x < maxTotalBearHunterPlayerAssistAI;x++)
 				if (JMG_Bear_Hunter_Player_Assist_AI::aiIds[x] == killerId)
 				{
-					JMG_Bear_Hunter_Player_Assist_AI::cash[x] += Get_Death_Points(obj)*2.0f;
+					JMG_Bear_Hunter_Player_Assist_AI::cash[x] += Get_Death_Points(obj)+Get_Damage_Points(obj)*Get_Max_Hitpoints(obj);
 					break;
 				}
 		return;
@@ -2722,15 +2793,17 @@
 	if (!(PlayerData.players[playerId]->killsWithoutGettingHurt % 10))
 	{
 		Commands->Give_Money(killer,50.0f,false);
-		JmgUtility::DisplayChatMessage(killer,11,194,255,"Bear Rug Co: Congrats, here's your $50.00 for 10 in a row without being hurt!");
-		Create_2D_Wave_Sound_Dialog_Player(killer,"BH62.mp3");
+		if (!PlayerData.players[playerId]->hasAnnounced10)
+			BearHunterVoiceSystem::PlayVoice(killer,"BH62.mp3","Bear Rug Co: Congrats, here's your $50.00 for 10 in a row without being hurt!");
+		else
+			JmgUtility::DisplayChatMessage(killer,127,127,255,"Bear Rug Co: Congrats, here's your $50.00 for 10 in a row without being hurt!");
+		PlayerData.players[playerId]->hasAnnounced10 = true;
 	}
 	PlayerData.players[playerId]->totalKills++;
 	if (!(PlayerData.players[playerId]->totalKills % 250))
 	{
 		Commands->Give_Money(killer,1000.0f,false);
-		JmgUtility::DisplayChatMessage(killer,11,194,255,"Bear Rug Co: $1,000.00 for the 250 pelts!");
-		Create_2D_Wave_Sound_Dialog_Player(killer,"BH63.mp3");
+		BearHunterVoiceSystem::PlayVoice(killer,"BH63.mp3","Bear Rug Co: $1,000.00 for the 250 pelts!");
 	}
 	if (Commands->Get_Random(0.0f,1.0f) < (1.0f-JMG_Bear_Hunter_Game_Control::gameTime/2000.0f)*0.25f)
 	{
@@ -2761,10 +2834,12 @@
 }
 void JMG_Security_Camera_Behavior::Created(GameObject *obj)
 {
-	zHeight = 1000.0f*tan(Get_Float_Parameter("IdleAimZAngleModifier")*PI180);
+	updateRateMultiplier = Get_Float_Parameter("UpdateRateMultiplier");
+	idleZAimAngleModifier = Get_Float_Parameter("IdleAimZAngleModifier");
 	enabled = true;
 	SeenTime = 0;
 	EnemyID = 0;
+	scanAngle = Get_Float_Parameter("Angle");
 	GameObject *floodLight = Commands->Create_Object_At_Bone(obj,Get_Parameter("FloodLightPreset"),"headlight00");
 	if (floodLight)
 	{
@@ -2886,43 +2961,16 @@
 {
 	if (number == 1)
 	{
-		Vector3 Pos = Commands->Get_Position(obj);
-		float Angle = Get_Float_Parameter("Angle")/4;
-		float Facing = Commands->Get_Facing(obj);
+		zHeight = 1000.0f*tan(idleZAimAngleModifier*PI180);
+		float Angle = scanAngle/4;
 		CameraFacingCount = 0;
 		IncreaseOrDecreaseCount = 1;
-		Facing = Facing-(Angle*2);
-		float ZPos = Commands->Get_Bone_Position(obj,"MuzzleA0").Z+zHeight;
-		float TempFacing = Facing*PI180;
-		CameraFacingLocation[0] = Pos;
-		CameraFacingLocation[0].X += cos(TempFacing)*1000.0f;
-		CameraFacingLocation[0].Y += sin(TempFacing)*1000.0f;
-		CameraFacingLocation[0].Z = ZPos;
-		Facing = Facing+Angle;
-		TempFacing = Facing*PI180;
-		CameraFacingLocation[1] = Pos;
-		CameraFacingLocation[1].X += cos(TempFacing)*1000.0f;
-		CameraFacingLocation[1].Y += sin(TempFacing)*1000.0f;
-		CameraFacingLocation[1].Z = ZPos;
-		Facing = Facing+Angle;
-		TempFacing = Facing*PI180;
-		CameraFacingLocation[2] = Pos;
-		CameraFacingLocation[2].X += cos(TempFacing)*1000.0f;
-		CameraFacingLocation[2].Y += sin(TempFacing)*1000.0f;
-		CameraFacingLocation[2].Z = ZPos;
-		Facing = Facing+Angle;
-		TempFacing = Facing*PI180;
-		CameraFacingLocation[3] = Pos;
-		CameraFacingLocation[3].X += cos(TempFacing)*1000.0f;
-		CameraFacingLocation[3].Y += sin(TempFacing)*1000.0f;
-		CameraFacingLocation[3].Z = ZPos;
-		Facing = Facing+Angle;
-		TempFacing = Facing*PI180;
-		CameraFacingLocation[4] = Pos;
-		CameraFacingLocation[4].X += cos(TempFacing)*1000.0f;
-		CameraFacingLocation[4].Y += sin(TempFacing)*1000.0f;
-		CameraFacingLocation[4].Z = ZPos;
-		CameraFacingUpdateTime = Get_Float_Parameter("Angle")*0.0085f;
+		cameraAngles[0] = -(Angle*2);
+		cameraAngles[1] = -Angle;
+		cameraAngles[2] = 0.0f;
+		cameraAngles[3] = Angle;
+		cameraAngles[4] = (Angle*2);
+		CameraFacingUpdateTime = scanAngle*0.0085f;
 		if (CameraFacingUpdateTime < 0.01f)
 			CameraFacingUpdateTime = 0.1f;
 		Commands->Start_Timer(obj,this,0.0f,2);
@@ -2932,7 +2980,7 @@
 	{
 		if (!enabled)
 		{
-			Commands->Start_Timer(obj,this,CameraFacingUpdateTime*Get_Float_Parameter("UpdateRateMultiplier"),2);
+			Commands->Start_Timer(obj,this,CameraFacingUpdateTime*updateRateMultiplier,2);
 			return;
 		}
 		if (!EnemyID)
@@ -2942,10 +2990,15 @@
 				IncreaseOrDecreaseCount = IncreaseOrDecreaseCount == -1 ? 1 : -1;
 			ActionParamsStruct params;
 			params.Set_Basic(this,70,1);
-			params.Set_Attack(CameraFacingLocation[CameraFacingCount],0,0,true);
+			Vector3 pos = Commands->Get_Position(obj);
+			float tempFacing = (Commands->Get_Facing(obj)+cameraAngles[CameraFacingCount])*PI180;
+			pos.X += cos(tempFacing)*1000.0f;
+			pos.Y += sin(tempFacing)*1000.0f;
+			pos.Z = Commands->Get_Bone_Position(obj,"MuzzleA0").Z+zHeight;
+			params.Set_Attack(pos,0,0,true);
 			Commands->Action_Attack(obj,params);
 		}
-		Commands->Start_Timer(obj,this,CameraFacingUpdateTime*Get_Float_Parameter("UpdateRateMultiplier"),2);
+		Commands->Start_Timer(obj,this,CameraFacingUpdateTime*updateRateMultiplier,2);
 	}
 	if (number == 3)
 	{
@@ -3051,8 +3104,7 @@
 		if (playerScoreNode)
 			playerScoreNode->ReturnedMedicalNeedle++;
 		JmgUtility::DisplayChatMessage(poker,200,127,255,"President of Corporate America: Thanks!");
-		JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Good work, he'll feel better in no time!");
-		JmgUtility::Create_2D_Wave_Sound_Dialog("BH64.mp3");
+		BearHunterVoiceSystem::PlayVoice("BH64.mp3","Bear Rug Co: Good work, he'll feel better in no time!");
 		for (int x = 1;x < 128;x++)
 		{
 			GameObject *player = Get_GameObj(x);
@@ -3060,6 +3112,8 @@
 				continue;
 			Commands->Give_Money(player,100.0f,0);
 		}
+		for (int x = 0;x < maxTotalBearHunterPlayerAssistAI;x++)
+			JMG_Bear_Hunter_Player_Assist_AI::cash[x] += 100.0f;
 		const char *weap = Get_Current_Weapon(poker);
 		if (weap && !_stricmp(weap,"Weapon_Needle"))
 			Commands->Select_Weapon(poker,"Weapon_Pistol_Player");
@@ -3145,8 +3199,7 @@
 	Commands->Fade_Background_Music("Unreal2_awakening_Hell_Ending.mp3",1000,1000);
 	for (int x = 0;x < 5;x++)
 		Commands->Create_Sound("Mission_Failed",Commands->Get_Position(obj),obj);
-	JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: We lost the President of Corporate America, our company is screwed!");
-	JmgUtility::Create_2D_Wave_Sound_Dialog("BH96.mp3");
+	BearHunterVoiceSystem::PlayVoice("BH96.mp3","Bear Rug Co: We lost the President of Corporate America, our company is screwed!");
 }
 void JMG_Bear_Hunter_President_Controller::damagedEvent(GameObject *obj,bool announce,bool palyinjured)
 {
@@ -3301,8 +3354,7 @@
 	bearHunterScoreSystem.Get_Current_Player_Score_Node(JmgUtility::JMG_Get_Player_ID(killer))->KilledTurrets++;
 	if (JMG_Bear_Hunter_Game_Control::gameTime && JMG_Bear_Hunter_Game_Control::gameTime <= 700 && JMG_Bear_Hunter_Game_Control::objective != 12698 && JMG_Bear_Hunter_Game_Control::turretsDestroyed >= 5)
 	{
-		JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: This is just getting to be too much, fall back and defend the President of Corporate America!");
-		JmgUtility::Create_2D_Wave_Sound_Dialog("BH65.mp3");
+		BearHunterVoiceSystem::PlayVoice("BH65.mp3","Bear Rug Co: This is just getting to be too much, fall back and defend the President of Corporate America!");
 		NewObjectiveSystemControl.Remove_Objective(5);
 		JmgUtility::SetHUDHelpText(JMG_Bear_Hunter_Game_Control::objective,Vector3(0,1,0));
 		JMG_Bear_Hunter_Game_Control::objective = 12698;
@@ -3313,8 +3365,7 @@
 	float compassDegree = atan2(turretPos.Y,turretPos.X)* (180.0f / PI);
 	char turretMsg[220];
 	sprintf(turretMsg,"Bear Rug Co: The %s Cannon Emplacement was destroyed!",JmgUtility::JMG_Get_Compass_Directions(compassDegree));
-	JmgUtility::Create_2D_Wave_Sound_Dialog("BH66.mp3");
-	JmgUtility::MessageAllPlayers(127,127,255,turretMsg);
+	BearHunterVoiceSystem::PlayVoice("BH66.mp3",turretMsg);
 }
 void JMG_Powerup_Grant_Cash::Custom(GameObject *obj,int message,int param,GameObject *sender)
 {
@@ -3335,7 +3386,12 @@
 {
 	if (message == CUSTOM_EVENT_POWERUP_GRANTED)
 	{
-		JMG_Bear_Hunter_Player_Soldier::hasGrenadeVest[JmgUtility::JMG_Get_Player_ID(sender)] = true;
+		int playerId = JmgUtility::JMG_Get_Player_ID(sender);
+		if (JMG_Bear_Hunter_Player_Soldier::hasGrenadeVest[playerId])
+			return;
+		BearHunterScoreSystem::BHScoreNode *node = bearHunterScoreSystem.Get_Current_Player_Score_Node(playerId);
+		node->C4VestPowerups++;
+		JMG_Bear_Hunter_Player_Soldier::hasGrenadeVest[playerId] = true;
 	}
 }
 void JMG_Powerup_Grant_Weapon_Clips::Custom(GameObject *obj,int message,int param,GameObject *sender)
@@ -3559,6 +3615,7 @@
 }
 void JMG_Bear_Hunter_Security_Turret_Truck::Created(GameObject *obj)
 {
+	driver = NULL;
 	firstTime = true;
 	Commands->Set_Animation(obj,"v_secPartsTruck.v_secPartsTruck",false,0,0.0f,0.0f,false);
 	if (JMG_Bear_Hunter_Game_Control::gameTime && JMG_Bear_Hunter_Game_Control::gameTime > 775)
@@ -3573,27 +3630,22 @@
 }
 void JMG_Bear_Hunter_Security_Turret_Truck::Custom(GameObject *obj,int message,int param,GameObject *sender)
 {
-	if (Get_Vehicle_Driver(obj) && Get_Vehicle_Driver(obj) != sender)
-		return;
-	if (message == CUSTOM_EVENT_VEHICLE_EXITED && !Get_Vehicle_Driver(obj) && (JMG_Bear_Hunter_Game_Control::gameTime > 775 || JMG_Bear_Hunter_Game_Control::truckTimeExtended) && !JMG_Bear_Hunter_Game_Control::hasGotTurrets)
+	if (message == CUSTOM_EVENT_VEHICLE_EXITED && driver == sender && (JMG_Bear_Hunter_Game_Control::gameTime > 775 || JMG_Bear_Hunter_Game_Control::truckTimeExtended) && !JMG_Bear_Hunter_Game_Control::hasGotTurrets)
 	{
+		driver = NULL;
 		NewObjectiveSystemControl.Set_Radar_Blip(10,obj);
-		JmgUtility::DisplayChatMessage(sender,127,127,255,"Bear Rug Co: Get back in that truck, it must make it back to base!");
-		Create_2D_Wave_Sound_Dialog_Player(sender,"BH67.mp3");
+		BearHunterVoiceSystem::PlayVoice(sender,"BH67.mp3","Bear Rug Co: Get back in that truck, it must make it back to base!");
 	}
-	if (message == CUSTOM_EVENT_VEHICLE_ENTERED && (JMG_Bear_Hunter_Game_Control::gameTime > 775 || JMG_Bear_Hunter_Game_Control::truckTimeExtended) && !JMG_Bear_Hunter_Game_Control::hasGotTurrets)
+	if (message == CUSTOM_EVENT_VEHICLE_ENTERED && (JMG_Bear_Hunter_Game_Control::gameTime > 775 || JMG_Bear_Hunter_Game_Control::truckTimeExtended) && !JMG_Bear_Hunter_Game_Control::hasGotTurrets && Get_Vehicle_Driver(obj) == sender)
 	{
+		driver = sender;
 		if (NewObjectiveSystemControl.Get_Objective_Status(14) == NewObjectiveSystem::Pending)
 		{
-			JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Looks like you forgot to deactivate the alarm, get out of there while you can, we're tracking lots of movement in the swamp!");
-			JmgUtility::Create_2D_Wave_Sound_Dialog("BH68.mp3");
+			BearHunterVoiceSystem::PlayVoice("BH68.mp3","Bear Rug Co: Looks like you forgot to deactivate the alarm, get out of there while you can, we're tracking lots of movement in the swamp!");
 			NewObjectiveSystemControl.Set_Objective_Status(14,NewObjectiveSystem::Failed);
 		}
 		else
-		{
-			JmgUtility::DisplayChatMessage(sender,127,127,255,"Bear Rug Co: Now all you have to do is return the truck to base.");
-			Create_2D_Wave_Sound_Dialog_Player(sender,"BH69.mp3");
-		}
+			BearHunterVoiceSystem::PlayVoice(sender,"BH69.mp3","Bear Rug Co: Now all you have to do is return the truck to base.");
 		if (firstTime)
 		{
 			firstTime = false;
@@ -3601,7 +3653,8 @@
 			Commands->Send_Custom_Event(obj,switchObj,5911911,60,0);
 		}
 		NewObjectiveSystemControl.Set_Objective_Status(9,NewObjectiveSystem::Accomplished);
-		NewObjectiveSystemControl.Add_Objective(10,NewObjectiveSystem::Tertiary,NewObjectiveSystem::Pending,12722,"",12722,JMG_Bear_Hunter_Game_Control::centerOfBase);
+		if (NewObjectiveSystemControl.Get_Objective_Status(10) == NewObjectiveSystem::NotDefined)
+			NewObjectiveSystemControl.Add_Objective(10,NewObjectiveSystem::Tertiary,NewObjectiveSystem::Pending,12722,"",12722,JMG_Bear_Hunter_Game_Control::centerOfBase);
 		NewObjectiveSystemControl.Set_Radar_Blip(10,JMG_Bear_Hunter_Game_Control::centerOfBase);
 	}
 }
@@ -3614,10 +3667,7 @@
 		NewObjectiveSystemControl.Remove_Objective(9);
 		NewObjectiveSystemControl.Remove_Objective(10);
 		if (JMG_Bear_Hunter_Game_Control::gameTime > 775)
-		{
-			JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: The truck was lost, GMax will pull another one out of the storage area for you shortly.");
-			JmgUtility::Create_2D_Wave_Sound_Dialog("BH70.mp3");
-		}
+			BearHunterVoiceSystem::PlayVoice("BH70.mp3","Bear Rug Co: The truck was lost, GMax will pull another one out of the storage area for you shortly.");
 	}
 }
 void JMG_Bear_Hunter_Security_Turret_Truck_Zone::Entered(GameObject *obj,GameObject *enterer)
@@ -3637,11 +3687,10 @@
 	}
 	if (JMG_Bear_Hunter_Game_Control::gameTime <= 775 && !JMG_Bear_Hunter_Game_Control::truckTimeExtended)
 	{
-		JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Thanks for the turret parts, its too late for us to set up the turrets, but here is your payment!");
-		JmgUtility::Create_2D_Wave_Sound_Dialog("BH71.mp3");
+		BearHunterVoiceSystem::PlayVoice("BH71.mp3","Bear Rug Co: Thanks for the turret parts, its too late for us to set up the turrets, but here is your payment!");
 		return;
 	}
-	GameObject *driver = Get_Vehicle_Driver(obj);
+	GameObject *driver = Get_Vehicle_Driver(enterer);
 	if (driver)
 	{
 		Commands->Give_Points(driver,250.0f,false);
@@ -3662,8 +3711,7 @@
 	turret = Commands->Create_Object("CnC_Ramjet_Camera",Vector3(50.220f,-701.401f,11.333f));
 	Commands->Set_Facing(turret,90.0f);
 	Commands->Attach_Script(turret,"JMG_AI_Ignore_Object","");
-	JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Thanks for the turret parts, we'll get these up right away, and here is your payment!");
-	JmgUtility::Create_2D_Wave_Sound_Dialog("BH72.mp3");
+	BearHunterVoiceSystem::PlayVoice("BH72.mp3","Bear Rug Co: Thanks for the turret parts, we'll get these up right away, and here is your payment!");
 }
 void JMG_Bear_Hunt_Final_Boss::Created(GameObject *obj)
 {
@@ -3921,8 +3969,7 @@
 	else
 		sprintf(deathMsg,"A %s killed the giant Mutant Rabbit!",Get_Translated_Preset_Name(killer));
 	JmgUtility::MessageAllPlayers(255,255,0,deathMsg);
-	JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: We did it, the President of Corporate America has been saved!");
-	JmgUtility::Create_2D_Wave_Sound_Dialog("BH73.mp3");
+	BearHunterVoiceSystem::PlayVoice("BH73.mp3","Bear Rug Co: We did it, the President of Corporate America has been saved!");
 	NewObjectiveSystemControl.Set_Objective_Status(8,NewObjectiveSystem::Accomplished);
 }
 void JMG_Bear_Hunt_Final_Boss::AttackTarget(GameObject *obj,GameObject *target,float distance)
@@ -5452,6 +5499,7 @@
 }
 void JMG_Bear_Hunter_Oil_Rig::Created(GameObject *obj)
 {
+	intPayout = 0.0f;
 	Commands->Enable_HUD_Pokable_Indicator(obj,true);
 	active = false;
 	char animation[32];
@@ -5478,12 +5526,21 @@
 		float frame = Get_Animation_Frame(obj);
 		if (active && frame >= Get_Float_Parameter("StartFrame") && frame <= Get_Float_Parameter("EndFrame"))
 		{
+			bool giveMoneyScore = false;
+			intPayout += 0.15f;
+			if (intPayout > 1.0f)
+			{
+				intPayout -= 1.0f;
+				giveMoneyScore = true;
+			}
 			for (int x = 1;x < 128;x++)
 			{
 				GameObject *player = Get_GameObj(x);
 				if (!player)
 					continue;
 				Commands->Give_Money(player,0.15f,false);
+				if (giveMoneyScore)
+					bearHunterScoreSystem.Get_Current_Player_Score_Node(x)->PumpJackMoney++;
 			}
 			for (int x = 0;x < maxTotalBearHunterPlayerAssistAI;x++)
 				JMG_Bear_Hunter_Player_Assist_AI::cash[x] += 0.3f;
@@ -5512,16 +5569,14 @@
 			oilRigCount++;
 			if (oilRigCount == 7)
 			{
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: That's all of the pump jacks in the North East, great work guys!");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH74.mp3");
+				BearHunterVoiceSystem::PlayVoice("BH74.mp3","Bear Rug Co: That's all of the pump jacks in the North East, great work guys!");
 				NewObjectiveSystemControl.Set_Objective_Status(16,NewObjectiveSystem::Accomplished);
 			}
 			else
 			{
 				char successMsg[220];
 				sprintf(successMsg,"Bear Rug Co: Oil rig on-line, %d more to go.",7-oilRigCount);
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH75.mp3");
-				JmgUtility::MessageAllPlayers(127,127,255,successMsg);
+				BearHunterVoiceSystem::PlayVoice("BH75.mp3",successMsg);
 				unsigned int textId = (oilRigCount == 1) ? 12752 : (oilRigCount == 2) ? 12753 : (oilRigCount == 3) ? 12754 : (oilRigCount == 4) ? 12755 : 12756;
 				NewObjectiveSystemControl.Set_Objective_Mission(16,textId,textId);
 			}
@@ -5559,13 +5614,16 @@
 		char params[256];
 		sprintf(params,"%s,%.2f,%.2f,1",Get_Parameter("RepairAnimation"),Get_Float_Parameter("StartFrame"),Get_Float_Parameter("EndFrame"));
 		Commands->Attach_Script(rig,"JMG_Bear_Hunter_Oil_Rig",params);
-		BearHunterScoreSystem::BHScoreNode *node = bearHunterScoreSystem.Get_Current_Player_Score_Node(JmgUtility::JMG_Get_Player_ID(obj));
+		BearHunterScoreSystem::BHScoreNode *node = bearHunterScoreSystem.Get_Current_Player_Score_Node(JmgUtility::JMG_Get_Player_ID(damager));
 		if (NewObjectiveSystemControl.Set_Objective_Status(17,NewObjectiveSystem::Accomplished))
 		{
 			Commands->Give_Points(damager,250.0f,false);
-			node->BonusObjectivesCompleted++;
-			node->totalObjectivesCompleted++;
-			node->ObjectiveOilRigsRepaired++;
+			if (node)
+			{
+				node->BonusObjectivesCompleted++;
+				node->totalObjectivesCompleted++;
+				node->ObjectiveOilRigsRepaired++;
+			}
 		}
 		Commands->Destroy_Object(obj);
 	}
@@ -5618,7 +5676,7 @@
 			else
 				NewObjectiveSystemControl.Set_Objective_Mission(18,12772+count,12772+count);
 			Commands->Give_Points(sender,250.0f,false);
-			BearHunterScoreSystem::BHScoreNode *node = bearHunterScoreSystem.Get_Current_Player_Score_Node(JmgUtility::JMG_Get_Player_ID(obj));
+			BearHunterScoreSystem::BHScoreNode *node = bearHunterScoreSystem.Get_Current_Player_Score_Node(JmgUtility::JMG_Get_Player_ID(sender));
 			node->BonusObjectivesCompleted++;
 			node->totalObjectivesCompleted++;
 			node->ObjectiveWeaponsFound++;
@@ -5660,27 +5718,13 @@
 			JMG_Bear_Hunter_Game_Control::weaponsUnlocked[Get_Int_Parameter("WeaponType")] = true;
 			switch (Get_Int_Parameter("WeaponType"))
 			{
-			case 0:
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Good work, all infantry classes now have a Twin Bow.");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH76.mp3");break;
-			case 1:
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Great work, basic infantry now have a 10 gauge shotgun.");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH77.mp3");break;
-			case 2:
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Due to your hard work, tier 1 infantry now have a FAMAS F1.");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH78.mp3");break;
-			case 3:
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Excellent work, tier 2 infantry now have the PPSh-41!");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH79.mp3");break;
-			case 4:
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Enjoy the AA12 with your tier 3 infantry!");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH80.mp3");break;
-			case 5:
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Engineers can now use the Beretta 93R.");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH81.mp3");break;
-			case 6:
-				JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: Wow, looks like that deer had blueprints for a plasma rifle, all classes now have a plasma rifle!");
-				JmgUtility::Create_2D_Wave_Sound_Dialog("BH82.mp3");break;
+			case 0:BearHunterVoiceSystem::PlayVoice("BH76.mp3","Bear Rug Co: Good work, all infantry classes now have a Twin Bow.");break;
+			case 1:BearHunterVoiceSystem::PlayVoice("BH77.mp3","Bear Rug Co: Great work, basic infantry now have a 10 gauge shotgun.");break;
+			case 2:BearHunterVoiceSystem::PlayVoice("BH78.mp3","Bear Rug Co: Due to your hard work, tier 1 infantry now have a FAMAS F1.");break;
+			case 3:BearHunterVoiceSystem::PlayVoice("BH79.mp3","Bear Rug Co: Excellent work, tier 2 infantry now have the PPSh-41!");break;
+			case 4:BearHunterVoiceSystem::PlayVoice("BH80.mp3","Bear Rug Co: Enjoy the AA12 with your tier 3 infantry!");break;
+			case 5:BearHunterVoiceSystem::PlayVoice("BH81.mp3","Bear Rug Co: Engineers can now use the Beretta 93R.");break;
+			case 6:BearHunterVoiceSystem::PlayVoice("BH82.mp3","Bear Rug Co: Wow, looks like that deer had blueprints for a plasma rifle, all classes now have a plasma rifle!");break;
 			}
 			if (Get_Int_Parameter("WeaponType") < 6)
 			{
@@ -5786,8 +5830,7 @@
 	}
 	if (NewObjectiveSystemControl.Get_Objective_Status(20) == NewObjectiveSystem::NotDefined)
 	{
-		JmgUtility::MessageAllPlayers(127,127,255,"Bear Rug Co: That deer looks real exotic, kill it so we can stuff it and sell it for big bucks!");
-		JmgUtility::Create_2D_Wave_Sound_Dialog("BH83.mp3");
+		BearHunterVoiceSystem::PlayVoice("BH83.mp3","Bear Rug Co: That deer looks real exotic, kill it so we can stuff it and sell it for big bucks!");
 		JMG_Bear_Hunter_Game_Control::IncreaseBonusObjectiveCount(20);
 		NewObjectiveSystemControl.Add_Objective(20,NewObjectiveSystem::Bonus,NewObjectiveSystem::Pending,12786,"",12786,JMG_Bear_Hunter_Game_Control::bonusObjectiveCount);
 	}
